//
//  NEXSnapshot.h
//  NumberEightCompiled
//
//  Created by Matthew Paletta on 2021-05-17.
//  Copyright © 2021 NumberEight Technologies Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "NEXLambdaFormatterTypes.h"

///
/// An immutable serialized set of topics and values at the moment the snapshot was created.
///
/// If a non-nil `NEXSnapshotGlimpseRuleHandler` was used when taking a snapshot, the values of the snapshot will reflect the output of that block, otherwise the default object serialization is used.
/// 
/// Generated by an `NEXSnapshotter`
///
NS_SWIFT_NAME(Snapshot)
@interface NEXSnapshot : NSObject

///
/// An immutable representation of NumberEight context at a given point in time.
///
/// @discussion If a non-nil `NEXSnapshotGlimpseRuleHandler` was used when taking a snapshot, the values of the snapshot will reflect the output of that block, otherwise the default object serialization is used.
///
@property (atomic, readonly, strong) NSDictionary<NSString*, NSString*>* _Nonnull dict;

/// The list of topics stored in the snapshot.
///
/// @discussion This is a equivalent to the following snippet:
/// @code
/// snapshot.dict.allKeys
/// @endcode
///
/// @return The list of topics stored in the snapshot.
///
@property (atomic, readonly, strong) NSArray<NSString*>* _Nonnull topics;

///
/// Returns a string representation of the snapshot, using the default formatter (`NEXJSONFormatter`).  This function is idempotent and thread safe.
///
/// @return String representation of the snapshot.
///
-(NSString* _Nonnull)toString;

///
/// Returns a string-representation of the snapshot, using the provided block as the formatter.  This function is idempotent and thread safe.
///
/// @param block The function used to return a string-represented of the snapshot.
///
/// @discussion We provide some built-in formatters for common formats including `NEXJSONFormatter`, and a `NEXQueryStringFormatter`.
///
/// @return String representation of the snapshot.
///
-(NSString* _Nonnull)toStringWithFormatter:(NEXSnapshotFormatterBlock _Nonnull )block;

@end
